
Ruby - Bug #8783

ruby 1.9/2.0 crash on exit on FreeBSD/powerpc64

08/13/2013 11:56 AM - chmeee (Justin Hibbits)

Status: Closed   

Priority: Normal   

Assignee: bsd   

Target version:    

ruby -v: ruby 2.0.0p195 (2013-05-14 revision

40734) [powerpc64-freebsd10.0]

Backport: 1.9.3: DONE, 2.0.0: DONE, 2.1: DONE

Description

On FreeBSD/powerpc64, ruby 1.9 and 2.0 segfault.  I traced this to the default stack being too small (12K).  A larger stack is

required, 4 pages is sufficient.

Related issues:

Related to Ruby - Bug #9436: r44670以降Solaris10でthread_pthread.cがコンパイルエラー Closed 01/21/2014

Associated revisions

Revision ad9d4f021129d9ca7270d72370b83a9a5ffec9a0 - 01/21/2014 07:26 AM - nobu (Nobuyoshi Nakada)

thread_pthread.c: expand timer thread stack size

thread_pthread.c (rb_thread_create_timer_thread): expand timer

thread stack size to get rid of segfault on FreeBSD/powerpc64.

based on the patch by Steve Wills at [ruby-core:59923].

[ruby-core:56590] [Bug #8783]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@44671 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision ad9d4f02 - 01/21/2014 07:26 AM - nobu (Nobuyoshi Nakada)

thread_pthread.c: expand timer thread stack size

thread_pthread.c (rb_thread_create_timer_thread): expand timer

thread stack size to get rid of segfault on FreeBSD/powerpc64.

based on the patch by Steve Wills at [ruby-core:59923].

[ruby-core:56590] [Bug #8783]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@44671 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 5bcb47db2bc3a60bc9ac04d94f1c9cb65fb0da31 - 02/14/2014 06:06 AM - U.Nakamura 

merge revision(s) 44670,44671,44675: [Backport #8783]

    thread_pthread.c: timer thread stack size

    * thread_pthread.c (rb_thread_create_timer_thread): define the stack

 size for timer thread at compile time.

* thread_pthread.c (rb_thread_create_timer_thread): expand timer

thread stack size to get rid of segfault on FreeBSD/powerpc64.

based on the patch by Steve Wills at [ruby-core:59923].

[ruby-core:56590] [Bug #8783]

    * thread_pthread.c (rb_thread_create_timer_thread): fix for platforms

      where PTHREAD_STACK_MIN is a dynamic value and not a compile-time

      constant.  [ruby-dev:47911] [Bug #9436]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_3@44940 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 5bcb47db - 02/14/2014 06:06 AM - U.Nakamura 

merge revision(s) 44670,44671,44675: [Backport #8783]

    thread_pthread.c: timer thread stack size

    * thread_pthread.c (rb_thread_create_timer_thread): define the stack
 size for timer thread at compile time.

* thread_pthread.c (rb_thread_create_timer_thread): expand timer

thread stack size to get rid of segfault on FreeBSD/powerpc64.

based on the patch by Steve Wills at [ruby-core:59923].

[ruby-core:56590] [Bug #8783]

    * thread_pthread.c (rb_thread_create_timer_thread): fix for platforms

      where PTHREAD_STACK_MIN is a dynamic value and not a compile-time

      constant.  [ruby-dev:47911] [Bug #9436]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_1_9_3@44940 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision b8cab3fc3b2ba2208aed9620fc46c58f09ab40ac - 02/16/2014 04:07 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) r44670,r44671,r44673,r44675: [Backport #8783]

    thread_pthread.c: timer thread stack size

    * thread_pthread.c (rb_thread_create_timer_thread): define the stack

 size for timer thread at compile time.

* thread_pthread.c (rb_thread_create_timer_thread): expand timer

thread stack size to get rid of segfault on FreeBSD/powerpc64.

based on the patch by Steve Wills at [ruby-core:59923].

[ruby-core:56590] [Bug #8783]

    * thread_pthread.c (rb_thread_create_timer_thread): fix for platforms

      where PTHREAD_STACK_MIN is a dynamic value and not a compile-time

      constant.  [ruby-dev:47911] [Bug #9436]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@45006 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision b8cab3fc - 02/16/2014 04:07 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) r44670,r44671,r44673,r44675: [Backport #8783]

    thread_pthread.c: timer thread stack size

    * thread_pthread.c (rb_thread_create_timer_thread): define the stack

 size for timer thread at compile time.

* thread_pthread.c (rb_thread_create_timer_thread): expand timer

thread stack size to get rid of segfault on FreeBSD/powerpc64.

based on the patch by Steve Wills at [ruby-core:59923].

[ruby-core:56590] [Bug #8783]

    * thread_pthread.c (rb_thread_create_timer_thread): fix for platforms

      where PTHREAD_STACK_MIN is a dynamic value and not a compile-time

      constant.  [ruby-dev:47911] [Bug #9436]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@45006 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 64e6dd621aef0cfffefae834a82b0ecb81a363df - 02/22/2014 07:17 AM - naruse (Yui NARUSE)

merge revision(s) 44670,44671,44673,44675: [Backport #8783]

    thread_pthread.c: timer thread stack size

    * thread_pthread.c (rb_thread_create_timer_thread): define the stack

 size for timer thread at compile time.

* thread_pthread.c (rb_thread_create_timer_thread): expand timer

thread stack size to get rid of segfault on FreeBSD/powerpc64.

based on the patch by Steve Wills at [ruby-core:59923].

[ruby-core:56590] [Bug #8783]

    * thread_pthread.c (rb_thread_create_timer_thread): fix for platforms

      where PTHREAD_STACK_MIN is a dynamic value and not a compile-time

      constant.  [ruby-dev:47911] [Bug #9436]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@45119 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 64e6dd62 - 02/22/2014 07:17 AM - naruse (Yui NARUSE)

merge revision(s) 44670,44671,44673,44675: [Backport #8783]
    thread_pthread.c: timer thread stack size

    * thread_pthread.c (rb_thread_create_timer_thread): define the stack

 size for timer thread at compile time.

* thread_pthread.c (rb_thread_create_timer_thread): expand timer

thread stack size to get rid of segfault on FreeBSD/powerpc64.

based on the patch by Steve Wills at [ruby-core:59923].

[ruby-core:56590] [Bug #8783]

    * thread_pthread.c (rb_thread_create_timer_thread): fix for platforms

      where PTHREAD_STACK_MIN is a dynamic value and not a compile-time

      constant.  [ruby-dev:47911] [Bug #9436]

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@45119 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 01/21/2014 05:43 AM - swills (Steve Wills)

- File patch-ppc64-fix-thread_pthread.c added

There is a back trace of this issue here:

http://lists.freebsd.org/pipermail/freebsd-ruby/2014-January/003968.html

And I've attached a proposed patch.

#2 - 01/21/2014 07:26 AM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

- % Done changed from 0 to 100

Applied in changeset r44671.

thread_pthread.c: expand timer thread stack size

thread_pthread.c (rb_thread_create_timer_thread): expand timer

thread stack size to get rid of segfault on FreeBSD/powerpc64.

based on the patch by Steve Wills at [ruby-core:59923].

[ruby-core:56590] [Bug #8783]

#3 - 01/21/2014 08:16 AM - nobu (Nobuyoshi Nakada)

- Backport changed from 1.9.3: UNKNOWN, 2.0.0: UNKNOWN to 1.9.3: REQUIRED, 2.0.0: REQUIRED, 2.1: REQUIRED

#4 - 02/14/2014 06:02 AM - usa (Usaku NAKAMURA)

- Related to Bug #9436: r44670以降Solaris10でthread_pthread.cがコンパイルエラー added

#5 - 02/14/2014 06:06 AM - usa (Usaku NAKAMURA)

- Backport changed from 1.9.3: REQUIRED, 2.0.0: REQUIRED, 2.1: REQUIRED to 1.9.3: DONE, 2.0.0: REQUIRED, 2.1: REQUIRED

backported r44670,r44671, and r44675 into ruby_1_9_3 at r44940.

#6 - 02/16/2014 04:07 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 1.9.3: DONE, 2.0.0: REQUIRED, 2.1: REQUIRED to 1.9.3: DONE, 2.0.0: DONE, 2.1: REQUIRED

r44670, r44671, r44673 and r44675 were backported to ruby_2_0_0 r45006.

#7 - 02/22/2014 07:17 AM - naruse (Yui NARUSE)

- Backport changed from 1.9.3: DONE, 2.0.0: DONE, 2.1: REQUIRED to 1.9.3: DONE, 2.0.0: DONE, 2.1: DONE

r45119

Files

patch-ppc64-fix-thread_pthread.c 746 Bytes 01/21/2014 swills (Steve Wills)
